package model;

public class RecursiveMethods {
	public String parenBit(String str) {
		// flag is false because we haven't seen '(' to begin with. 
		return  parenBitHelper(str, 0, false, "");
	}
	
	/*
	 * Recursive helper method:
	 * 1. Keep track of which char is being considered. 
	 * 2. Keep track of where are we are (i.e,. has a '(' or ')' been seen). 
	 * 3. Keep track of the intermediate output string to be returned.
	 */
	private String parenBitHelper(String str, int index, boolean started, String resultSoFar) {
		// the current character being considered for inclusion or not.
		char c = str.charAt(index);
		if(c == ')') { /* the output is ready to be returned, as all later chars can be ignored */
			return resultSoFar + ")";
		}
		else if(c == '(') { /* start accumulating output until ')' is seen */
			return parenBitHelper(str, index + 1, true, resultSoFar + c); // What about just "("
		}
		else { /* the char is either within () or outside () */
			if(started) { // '(' has been seen -> include c
				return parenBitHelper(str, index + 1, true, resultSoFar + c);
			}
			else { // '(' has not been seen -> exclude c
				return parenBitHelper(str, index + 1, false, resultSoFar);
			}
		}
	}
}
